<?php
/*******************************************************************************
* Simple Chart © By Akyhne													   *
********************************************************************************
* bbc_generator.php V 0.5											           *
*******************************************************************************/


?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Simple Chart BBC Generator</title>
</head>
<style type="text/css">
body, html
{
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
}
table#values td
{
	white-space: nowrap;
	vertical-align: bottom;
}
table chart_table
{
}
td.options_td, td.input_td, td.output_td
{
	padding: 5px;
	border: 1px solid #bbe;
}
td.options_td
{
	background-color: #E7EAEF;
}
td.input_td
{
	background-color: #F0F4F7;
}
td.output_td
{
	background-color: #d7daef;
	padding: 25px 5px 15px;
}
#layout_container
{
	padding: 5px 3px;
	background-color: #F8FcFe;
	border: 1px solid #dde;
}
#select_code
{
	margin-left: 6px;
}
.poss_disabled
{
	/*background-color: #eee;*/
	/*border: 1px solid #999;*/
}
#warns
{
	padding-top: 1em;
}
div#warnings
{
	width: 100%;
	min-height: 150px;
	max-height: 150px;
	overflow: scroll;
	background-color: #fdf;
	border: 1px solid #999;
	padding: 1px 5px;
}
div#warnings strong
{
	font-size: 1.1em;
}
p.alerts
{
	font-size: 9px;
}

</style>

<script type="text/javascript">

function createCookie(name,value,days) {
	if (days) {
		var date = new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		var expires = "; expires="+date.toGMTString();
	}
	else var expires = "";
	document.cookie = name+"="+value+expires+"; path=/";
}

function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}
function UpdateOnLoad()
{
	d = readCookie('CurrLayout');
	if (d)
	{
		var CoooooookIt = d.split(",");
		SetLayout(CoooooookIt[0], CoooooookIt[1]);
		document.getElementById('preview_img').src = 'images/previews/_'+CoooooookIt[1]+'.png';
		document.getElementById('ch_layout_'+CoooooookIt[1]).checked = 'checked';
	}
}

	var warnings = new Object;
	warnings.inproperType = new Array();
	warnings.names = new Array();
	warnings.notFloat = new Array();

function is_array(input)
{
	return typeof(input)=='object'&&(input instanceof Array);
}

function in_array(needle, haystack) {
	var length = haystack.length;
	for(var i = 0; i < length; i++) {
		if(haystack[i] == needle) return true;
	}
	return false;
}

function CheckInput(inp, place, type)
{
	errorlevel = false;

	if (type == 'quotes')
	{
		if (inp.search('"') > -1)
		{
			warnings.inproperType[warnings.inproperType.length] = 'Warning! You may not use <strong>'+type+'</strong> in <strong>'+place+'</strong>';
			errorlevel = true;
		}
	}
	if (type == 'backslashes')
	{
		if (inp.search('\\\\') > -1)
		{
			warnings.inproperType[warnings.inproperType.length] = 'Warning! You may not use <strong>'+type+'</strong> in <strong>'+place+'</strong>';
			errorlevel = true;
		}
	}
	return errorlevel;
}

function UpdateOutput()
{
	document.getElementById('warnings').innerHTML = 'p';

	var out = '[chart';
	var chart_title_input = document.getElementById('ch_title').value;
	CheckTitleError = CheckInput(chart_title_input, 'Title', 'quotes');
	var chart_title_input_disabled = document.getElementById('ch_title').disabled;
	var title_output = chart_title_input != '' & chart_title_input != ' ' && CheckTitleError !== true && chart_title_input_disabled === false ? ' title="' + chart_title_input + '"' : '';
	
	var chart_width_input = document.getElementById('ch_width').value;
	var chart_width_input_disabled = document.getElementById('ch_width').disabled;
	var width_val = parseInt(chart_width_input) > 0 ? (parseInt(chart_width_input) < 80 ? 80 : (parseInt(chart_width_input) > 1000 ? 1000 : parseInt(chart_width_input))) : '';
	var width_output = width_val > 0 && chart_width_input_disabled === false ? ' width=' + width_val : '';
	warnings.width = (parseInt(chart_width_input) > 0 && (parseInt(chart_width_input) < 80 || parseInt(chart_width_input) > 1000) ? 'Warning! Width should be minimum 80 or max. 1000. You set a smaller width and this has been corrected in the final output.' : '');
	
	var chart_height_input = document.getElementById('ch_height').value;
	var chart_height_input_disabled = document.getElementById('ch_height').disabled;
	var height_val = parseInt(chart_height_input) > 0 ? (parseInt(chart_height_input) < 100 ? 100 : (parseInt(chart_height_input) > 1000 ? 1000 : parseInt(chart_height_input))) : '';
	var height_output = height_val > 0 && chart_height_input_disabled === false ? ' height=' + height_val : '';
	warnings.height = (parseInt(chart_height_input) > 0 && (parseInt(chart_height_input) < 100 || parseInt(chart_height_input) > 1000) ? 'Warning! Height should be minimum 100 and max. 1000. You set a to small or to large height and this has been corrected in the final output.' : '');
	
	var chart_align_input = document.getElementById('ch_align').value;
	var chart_align_status = document.getElementById('ch_align').disabled;
	var align_output = chart_align_input != '' && chart_align_input != 'nan' && chart_align_status === false ? ' align=' + chart_align_input : '';

	var chart_max_input = document.getElementById('ch_max').value;
	chart_max_input = parseFloat(chart_max_input.replace(/,/,'.'));
	chart_max_input = chart_max_input >= 0 ? chart_max_input : '';
	lay = document.getElementById('layout').value;
	max_val = 0;
	if (chart_max_input != '')
	{
		y = 1;
		pie_values = 0;
		while (document.getElementById('name_'+y))
		{
			i = 1;
			while (document.getElementById('val_'+y+'_'+i))
			{
				if (document.getElementById('val_'+y+'_'+i).disabled === false)
				{
					curr_val = document.getElementById('val_'+y+'_'+i).value;
					curr_val = parseFloat(curr_val.replace(/,/,'.'));
					if (curr_val > 0)
						pie_values = pie_values + curr_val;
					if (curr_val > max_val)
						max_val = curr_val;
				}
				i++;
			}
			y++;
		}
		if (lay != 'pie')
		{
			if (chart_max_input < max_val)
			{
				warnings.maxValue = 'Max value is to small! Max value for charts, gauges and stars, should be higher than the highest value of the chart. You set the max value to <strong>'+chart_max_input+'</strong> and the highest value is <strong>'+max_val+'</strong>. The max input will have no effect, untill you correct this!!';
				chart_max_input = '';
			}
		} else
		{
			if (chart_max_input < pie_values)
			{
				warnings.maxValue = 'If you want to use the max value on pies, the max should be set to a higher value, than the sum of the chart values. You set the sum to <strong>'+chart_max_input+'</strong> and the sum of the chart values is <strong>'+pie_values+'</strong>';
				chart_max_input = '';
			}
		}
	}
	var max_output = chart_max_input != '' ? ' max=' + chart_max_input : '';

	var array_names = Array();
	// Check names aren't identical
	y = 1;
	while (document.getElementById('name_'+y))
	{
		if (d = document.getElementById('name_'+y).disabled === false)
		{
			document.getElementById('name_'+y).style.backgroundColor = '';
			d = document.getElementById('name_'+y).value;
			if (d != '')
			{
				if (in_array(d, array_names))
				{
					warnings.names[warnings.names.length] = 'Warning! You have duplicate names in the chart! The duplicate names, has been colored yellow.';
					document.getElementById('name_'+y).style.backgroundColor = '#f0f000';
				}
				array_names[array_names.length] = d;
			}
		}
		y++;
	}
			

	var layout_input = document.getElementById('layout').value;
	var chart_layout_output = ' layout='+layout_input;


	// Fetch the open charts cells and all its values
	y = 1;
	var dim_arr = new Array();
	while (document.getElementById('name_'+y))
	{
		dim_arr[y] = new Array();
		var g = String(document.getElementById('name_'+y).value);
		dim_arr[y][0] = g;
		if (g != '')
		{
			i = 1;
			while (document.getElementById('val_'+y+'_'+i))
			{
				if (document.getElementById('val_'+y+'_'+i).disabled === false)
				{
					dim_arr[y][i] = document.getElementById('val_'+y+'_'+i).value;
				}
				i++;
			}
		}
		else
		{
			i = 1;
			rowHasInput = false;
			while (document.getElementById('val_'+y+'_'+i))
			{
				if (document.getElementById('val_'+y+'_'+i).disabled === false && document.getElementById('val_'+y+'_'+i).value != '')
					rowHasInput = true;
				i++;
			}
			if (rowHasInput === true)
				warnings.names[warnings.names.length] = 'There is no name set for row <strong>'+y+'</strong>. The row wil not be used, until this is fixed!';
			rowHasInput = false;
		}
		y++;
	}


	text = '';
	for (t = 1; t < dim_arr.length; t++)
	{
		j = dim_arr[t].length;
		if (j > 1)
		{
			//text = text + dim_arr[t][0]+'=';
			valid_outputs = false;
			valid_numbers = '';
			for (u = 1; u < j; u++)
			{
				// Is it a number?
				test_string = dim_arr[t][u];
				test_float = parseFloat(test_string.replace(/,/,'.'));
				float_string = test_float.toString();
				if (test_string.length == float_string.length && float_string != 'NaN')
				{
					valid_outputs = true;
					valid_numbers = valid_numbers + test_string + ';';
					document.getElementById('val_' + t + '_' + u).style.backgroundColor = '';
				}
				else
				if (test_string != '')
				{
					warnings.notFloat[warnings.notFloat.length] = 'Warning! The value, \'<strong>' + test_string + '</strong>\', in ' + t + ',' + u + 'is not a number in the cell. The cell is colored to guide you there. You can only use <strong>[0-9]</strong> and <strong>,</strong> or <strong>.</strong> as float separator.';
					document.getElementById('val_' + t + '_' + u).style.backgroundColor = '#ff8888';
				}
			}
			CheckNamesError = CheckInput(dim_arr[t][0], 'Chart names', 'backslashes');
			if (valid_outputs === true && CheckNamesError !== true)
			{
				text = text + dim_arr[t][0]+'=' + valid_numbers;
				text = text.slice(0, -1);
				text = text + '|';
			}
		}
	}
	text = text.slice(0, -1);

	out = out + width_output + height_output + title_output + align_output + chart_layout_output + max_output + ']' + text + '[/chart]';

	document.getElementById('bbc_output').value = out;

	var warningText = '';
	for (var i in warnings)
	{
		if (is_array(warnings[i]))
		{
			for (var y in warnings[i])
			{
				warningText = warningText +'<p class="alerts">- '+warnings[i][y] + '</p>';
				delete warnings[i][y];
			}
		}
		else
		{
			if (warnings[i] != '')
			{
				warningText = warningText + '<p class="alerts">-- ' + warnings[i] + '</p>';
				warnings[i] = '';
			}
		}
	}
	document.getElementById('warnings').innerHTML = warningText;
}

function SetLayout(the_layout, strict_layout)
{
	document.getElementById('layout').value = the_layout;
	document.getElementById('strict_layout').value = strict_layout;
	document.getElementById('preview_img').src = 'images/previews/_'+strict_layout+'.png';
	createCookie('CurrLayout', the_layout + ',' + strict_layout, 1);
}
function append_table()
{
	d = document.getElementById('strict_layout').value;

	if (d == '' || d == 'h')
		Horizontal_layout();
	else
	if (d == 'v')
		Vertical_layout();
	else
	if (d == 'hml')
		Horizontal_ml_layout();
	else
	if (d == 'vml')
		Vertical_ml_layout();
	else
	if (d == 'pie')
		Pie_layout();
	else
	if (d == 'gauge')
		Gauge_layout();
	else
	if (d == 'stars')
		Stars_layout();
}

function EnableAlign(do_it)
{
	if (do_it === false)
	{
		document.getElementById('ch_align').disabled = true;
		document.getElementById('ch_align').style.backgroundColor = '#eeeeee';
		document.getElementById('ch_align').style.border = '1px solid #999';
	}
	else
	{
		document.getElementById('ch_align').disabled = false;
		document.getElementById('ch_align').style.backgroundColor = '';
		document.getElementById('ch_align').style.border = '';
	}
}

function EnableHeight(do_it)
{
	if (do_it === false)
	{
		document.getElementById('ch_height').disabled = true;
		document.getElementById('ch_height').style.backgroundColor = '#eeeeee';
		document.getElementById('ch_height').style.border = '1px solid #999';
	}
	else
	{
		document.getElementById('ch_height').disabled = false;
		document.getElementById('ch_height').style.backgroundColor = '';
		document.getElementById('ch_height').style.border = '';
	}
}

function EnableTitle(do_it)
{
	if (do_it === false)
	{
		document.getElementById('ch_title').disabled = true;
		document.getElementById('ch_title').style.backgroundColor = '#eeeeee';
		document.getElementById('ch_title').style.border = '1px solid #999';
	}
	else
	{
		document.getElementById('ch_title').disabled = false;
		document.getElementById('ch_title').style.backgroundColor = '';
		document.getElementById('ch_title').style.border = '';
	}
}

function EnableWidth(do_it)
{
	if (do_it === false)
	{
		document.getElementById('ch_width').disabled = true;
		document.getElementById('ch_width').style.backgroundColor = '#eeeeee';
		document.getElementById('ch_width').style.border = '1px solid #999';
	}
	else
	{
		document.getElementById('ch_width').disabled = false;
		document.getElementById('ch_width').style.backgroundColor = '';
		document.getElementById('ch_width').style.border = '';
	}
}

function Close_MultiLevel()
{
	y = 1;
	while (document.getElementById('name_'+y))
	{
		document.getElementById('name_'+y).disabled = false;
		document.getElementById('name_'+y).style.backgroundColor = '';
		document.getElementById('name_'+y).style.border = '';
		i = 1;
		while (document.getElementById('val_'+y+'_'+i))
		{
			if (i > 1)
			{
				document.getElementById('val_'+y+'_' + i).disabled = true;
				document.getElementById('val_'+y+'_' + i).style.backgroundColor = '#eeeeee';
				document.getElementById('val_'+y+'_' + i).style.border = '1px solid #999999';
			} else{
				document.getElementById('val_'+y+'_' + i).disabled = false;
				document.getElementById('val_'+y+'_' + i).style.backgroundColor = '';
				document.getElementById('val_'+y+'_' + i).style.border = '';
			}
			i++;
		}
		y++;
	}
}

function Open_MultiLevel()
{
	y = 1;
	while (document.getElementById('name_'+y))
	{
		document.getElementById('name_'+y).disabled = false;
		document.getElementById('name_'+y).style.backgroundColor = '';
		document.getElementById('name_'+y).style.border = '';
		i = 1;
		while (document.getElementById('val_'+y+'_'+i))
		{
			document.getElementById('val_'+y+'_' + i).disabled = false;
			document.getElementById('val_'+y+'_' + i).style.backgroundColor = '';
			document.getElementById('val_'+y+'_' + i).style.border = '';
			i++;
		}
		y++;
	}
}



function CloseAll_But_First()
{
	y = 1;
	while (document.getElementById('name_'+y))
	{
		if (y > 1)
		{
			document.getElementById('name_'+y).disabled = true;
			document.getElementById('name_'+y).style.backgroundColor = '#eeeeee';
			document.getElementById('name_'+y).style.border = '1px solid #999';
		}
		i = 1;
		while (document.getElementById('val_'+y+'_'+i))
		{
			if (i > 1 || y > 1)
			{
				document.getElementById('val_'+y+'_' + i).disabled = true;
				document.getElementById('val_'+y+'_' + i).style.backgroundColor = '#eeeeee';
				document.getElementById('val_'+y+'_' + i).style.border = '1px solid #999';
			}
			i++;
		}
		y++;
	}
}

function addColumnToTable()
{
	var tbl = document.getElementById('values');
	var lastRow = tbl.rows.length;
	var lastColumn = tbl.rows[0].cells.length;
	
	if (lastColumn <= 10)
	{
		for (i = 0; i < lastRow; i++)
		{
			var cellLeft = tbl.rows[i].insertCell(lastColumn);
			var el = document.createElement('br');
				el.type = 'br';
				cellLeft.appendChild(el);
			var el = document.createElement('input');
				el.type = 'text';
				el.name = 'txtRow' + lastColumn;
				el.id = 'val_'+(i+1)+'_'+lastColumn;
				el.maxlength = 8;
				el.size = 6;
				el.change = UpdateOutput;
				el.onkeyup = UpdateOutput;
				cellLeft.appendChild(el);
		}
	}
	
}

function addRowToTable()
{
	var tbl = document.getElementById('values');
	var lastRow = tbl.rows.length;
	var lastColumn = tbl.rows[0].cells.length;
	// if there's no header row in the table, then iteration = lastRow + 1
	var iteration = lastRow;
	var row = tbl.insertRow(lastRow);
	row.style = 'background-color:#ff0000';
	tbl.appendChild(row);

	iteration = iteration + 1;
	if (iteration < 51)
	{
		for (i = 0; i < lastColumn; i++)
		{
			var cellRight = row.insertCell(i);
			if (i == 0)
			{
				var el = document.createElement('label');
				el.type = 'label';
				el.htmlFor = 'name_'+iteration;
				el.innerHTML = 'Name of #'+iteration;
				cellRight.appendChild(el);

				var el = document.createElement('br');
				el.type = 'br';
				cellRight.appendChild(el);

				var el = document.createElement('input');
				el.type = 'text';
				el.name = 'name_' + iteration;
				el.id = 'name_'+iteration;
				el.size = 20;
				cellRight.appendChild(el);
			} else {
				var el = document.createElement('input');
				el.type = 'text';
				el.name = 'txtRow' + iteration;
				el.id = 'val_'+iteration+'_'+i;
				el.maxlength = 8;
				el.size = 6;
				el.change = UpdateOutput;
				el.onkeyup = UpdateOutput;
				cellRight.appendChild(el);
			}
		}
		append_table();
	}
}

function removeRowFromTable()
{
	var tbl = document.getElementById('values');
	var lastRow = tbl.rows.length;
	if (lastRow > 2)
		tbl.deleteRow(lastRow - 1);
}
</script>

<body onload="UpdateOnLoad();">
<table id="chart_table">
	<tr>
		<td class="options_td" width="10%" valign="top">
			<table id="settings">
				<tr>
					<td>
						<label for="ch_title">Title (Optional)</label><br />
						<input name="ch_title" type="text" id="ch_title" size="25" maxlength="200" onchange="UpdateOutput()" onkeyup="UpdateOutput()" tabindex="1" />
					</td>
				</tr>
				<tr>
					<td>
						<label for="ch_width">Width (Optional)</label><br />
						<input name="ch_width" type="text" id="ch_width" size="8" maxlength="100" onchange="UpdateOutput()" onkeyup="UpdateOutput()" tabindex="2" />
					</td>
				</tr>
				<tr>
					<td>
						<label for="ch_height">Height (Optional)</label><br />
						<input name="ch_height" type="text" id="ch_height" size="8" maxlength="100" onchange="UpdateOutput()" onkeyup="UpdateOutput()" tabindex="3" disabled="disabled" style="background-color: #eee;" />
					</td>
				</tr>
				<tr>
					<td>align
					<label for="ch_align">Align (Optional)</label>
					<select name="ch_align" id="ch_align" onchange="UpdateOutput()" tabindex="4">
						<option value="">Select...</option>
						<option value="nan">Not used</option>
						<option value="left">Left</option>
						<option value="right">Right</option>
						<option value="center">Center</option>
						<option value="none">None</option>
					</select></td>
				</tr>
				<tr>
					<td>
						<label for="ch_max">Max (Optional)</label><br />
						<input name="ch_max" type="text" id="ch_max" size="8" maxlength="100" onchange="UpdateOutput()" onkeyup="UpdateOutput()" tabindex="5" />
					</td>
				</tr>
				<tr>
					<td align="center"><img id="preview_img" src="images/previews/_hml.png" alt="" width="80" height="80" />
					</td>
				</tr>
			</table>
		</td>
		<td class="input_td">
			<div id="layout_container">
			<input type="hidden" name="layout" id="layout" value="h" />
			<input type="hidden" name="strict_layout" id="strict_layout" value="h" />

			<input type="radio" name="ch_layout" id="ch_layout_h" value="Horizontal" onclick="Horizontal_layout();" checked="checked" />
            <label for="ch_layout">Horizontal</label>

			<input type="radio" name="ch_layout" id="ch_layout_v" value="Vertical" onclick="Vertical_layout();" />
            <label for="ch_layout">Vertical</label>

			<input type="radio" name="ch_layout" id="ch_layout_hml" value="Multi Level Vertical" onclick="Horizontal_ml_layout();" />
            <label for="ch_layout">Multi Level Horizontal</label>

			<input type="radio" name="ch_layout" id="ch_layout_vml" value="Multi Level Vertical" onclick="Vertical_ml_layout();" />
			<label for="ch_layout">Multi Level Vertical</label>
			
            
            <input type="radio" name="ch_layout" id="ch_layout_pie" value="Pie Chart" onclick="Pie_layout();" />
			<label for="ch_layout">Pie Chart</label>

			<input type="radio" name="ch_layout" id="ch_layout_gauge" value="Gauge" onclick="Gauge_layout();" />
			<label for="ch_layout">Gauge</label>

			<input type="radio" name="ch_layout" id="ch_layout_stars" value="Stars" onclick="Stars_layout();" />
			<label for="ch_layout">Stars</label>
			</div>
			<table id="values">
				<tr>
					<td>
						<label for="name_1">Name of #1</label><br />
						<input name="name_1" type="text" id="name_1" size="20" maxlength="150" onchange="CheckInput(this.value, 'Chart names', 'backslashes'); UpdateOutput()" onkeyup="CheckInput(this.value, 'Chart names', 'backslashes'); UpdateOutput()" />
					</td><?php create_list(1); ?>
				</tr>

				<tr>
					<td>
						<label for="name_2">Name of #2</label><br />
						<input name="name_2" type="text" id="name_2" size="20" maxlength="150" onchange="UpdateOutput()" onkeyup="UpdateOutput()" />
					</td><?php create_list(2); ?>
				</tr>

				<tr>
					<td>
						<label for="name_3">Name of #3</label><br />
						<input name="name_3" type="text" id="name_3" size="20" maxlength="150" onchange="UpdateOutput()" onkeyup="UpdateOutput()" />
					</td><?php create_list(3); ?>
				</tr>

				<tr>
					<td>
						<label for="name_4">Name of #4</label><br />
						<input name="name_4" type="text" id="name_4" size="20" maxlength="150" onchange="UpdateOutput()" onkeyup="UpdateOutput()" />
					</td><?php create_list(4); ?>
				</tr>

				<tr>
					<td>
						<label for="name_5">Name of #5</label><br />
						<input name="name_5" type="text" id="name_5" size="20" maxlength="150" onchange="UpdateOutput()" onkeyup="UpdateOutput()" />
					</td><?php create_list(5); ?>
				</tr>
			</table>
			<input name="addrow" type="button" value="+" onclick="addRowToTable();" alt="Add row" title="Add row" />
			<input name="removerow" type="button" value="-" onclick="removeRowFromTable();" alt="Remove row" title="Remove row"/>
			<input name="addcolumn" type="button" value="+" onclick="addColumnToTable();" alt="Add column" title="Add column" />
		</td>
	</tr>
	<tr>
		<td class="output_td" colspan="2">
			<label for="bbc_output">BBC Output</label><a id="select_code" href="#">Select</a><br />
			<input name="bbc_output" id="bbc_output" type="text" size="200" />
		</td>
	</tr>
	<tr>
		<td id="Warns" colspan="2">Warnings :<div id="warnings"></div>
		</td>
	</tr>
</table>
<script type="text/javascript">

function Horizontal_layout()
{
	SetLayout('h', 'h');
	Close_MultiLevel();
	EnableAlign(true);
	EnableTitle(true);
	EnableWidth(true);
	EnableHeight(false);
	UpdateOutput();
}

function Vertical_layout()
{
	SetLayout('v', 'v');
	Close_MultiLevel();
	EnableAlign(true);
	EnableTitle(true);
	EnableWidth(true);
	EnableHeight(true);
	UpdateOutput();
}

function Horizontal_ml_layout()
{
	SetLayout('h', 'hml');
	Open_MultiLevel();
	EnableAlign(true);
	EnableTitle(true);
	EnableWidth(true);
	EnableHeight(false); 
	UpdateOutput();
}

function Vertical_ml_layout()
{
	SetLayout('v', 'vml');
	Open_MultiLevel();
	EnableAlign(true);
	EnableTitle(true);
	EnableWidth(true);
	EnableHeight(true);
	UpdateOutput();
}

function Pie_layout()
{
	SetLayout('pie', 'pie');
	Close_MultiLevel();
	EnableAlign(true);
	EnableTitle(true);
	EnableWidth(false);
	EnableHeight(false);
	UpdateOutput();
}

function Gauge_layout()
{
	SetLayout('gauge', 'gauge');
	CloseAll_But_First();
	EnableAlign(false);
	EnableTitle(true);
	EnableWidth(true);
	EnableHeight(false);
	UpdateOutput();
}

function Stars_layout()
{
	SetLayout('stars', 'stars');
	CloseAll_But_First();
	EnableAlign(false);
	EnableTitle(false);
	EnableWidth(false);
	EnableHeight(false);
	UpdateOutput();
}

</script>
</body>
</html>
<?php
function create_list($dig)
{
	$out_p = '';
	for ($i = 1; $i < 6;$i++)
		$out_p .= '
					<td><br />
						<input' . ($i > 1 ? ' class="poss_disabled" style="background-color: #eee; border: 1px solid #999"' : '') . ' name="val_' . $dig . '" type="text" id="val_' . $dig . '_' . $i . '" size="6" maxlength="8" onchange="UpdateOutput()" onkeyup="UpdateOutput()"'. ($i > 1 ? ' disabled' : '') . ' />
					</td>';
	echo $out_p;
}